/*
 *    QueryHistoryModel.java
 *    Copyright (C) 2001 New Zealand Digital Library Project
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


package org.nzdl.gsdl.SimpleGraphicalClient;

import java.util.*;
import javax.swing.event.*;
import javax.swing.*;
import javax.swing.table.*;

class QueryHistoryModel extends AbstractTableModel implements Constants {

    private ArrayList historyItems; 

    public QueryHistoryModel() {
	super();
	historyItems = new ArrayList();
    }

	
    public void add(QueryHistoryItem queryHistoryItem) {
	historyItems.add(0,queryHistoryItem); //add at the top!
	//fireTableDataChanged(); //too general
	fireTableRowsInserted(0,0);
    }
	
    public int getColumnCount() {
	return  QUERY_HISTORY_COLUMN_TITLES.length;
    }

    public int getRowCount() {
	return historyItems.size();
    }

    public String getColumnName(int column) {
	return QUERY_HISTORY_COLUMN_TITLES[column];
    }

    public Object getValueAt( int row, int column ) {
	// column resolution is a bit awkward
	// Collection = 0
	// Terms = 1

	if (column == 0) return new CollectionName(((QueryHistoryItem)historyItems.get(row)).getCollectionName());

	if (column == 1) return ((QueryHistoryItem)historyItems.get(row)).getQuery();
	return "row" + row + "col" + column;
    }
   


    class CollectionName extends Object {
	String string;

	CollectionName(String newString) {
	    string = newString;
	}

	public String toString() {
	    return string;
	}

    } // CollectionName


} //QueryHistoryModel
